#===============================================================================
#
#	チャットクラス
#
class Chat

	attr_reader :script
	attr_reader :user
	attr_reader :post_value

	def initialize
		@now_time = Time.now
		@log_name = 'data/chat-%Y-%m.txt'
		@script = File.basename(ENV['SCRIPT_NAME'] || '')
		@user = @script.gsub(/\..*/, '')
	end

	def set_post_value(value)
		@post_value = value
	end

	def receive_post(cgi)
		if(cgi.params['post'][0] == @post_value)
			open(@now_time.strftime(@log_name), 'a') {|fh|
				fh.write("%d,%s,%s,%s\n" % [@now_time.to_i, @user, cgi.params['face'][0], cgi.params['text'][0]])
			}
			if(@user == 'taro')									# 太郎が発言したら、携帯電話にメールを送信
#				send_mail("echo '%s' | mail -r taro@example.com father@cellular.com", cgi.params['text'][0])
			end
			unless(@user == 'taro')								# 太郎以外が発言したら、LED 点滅開始
#				on_led
			end
		end
		if(@user == 'taro')										# 太郎がアクセスしたら、LED 点滅終了
#			off_led
		end
	end

	def send_mail(command, message)
		system(command % message)
	end

	def on_led
		require 'socket'
		sock = UDPSocket.new()
		sock.connect('lcd_panel', 7544)
		sock.send('taro_on:hoge', 0)
		sock.close
	end

	def off_led
		require 'socket'
		sock = UDPSocket.new()
		sock.connect('lcd_panel', 7544)
		sock.send('taro_off:fuga', 0)
		sock.close
	end

	def pick_logs(n_max = 10)
		@logs = []
		n = n_max; cur_month = @now_time
		log_file = cur_month.strftime(@log_name)
		(1..3).each {											# 3 ヶ月分前まで探しに行く
			open(log_file) {|fh|
				fh.readlines.reverse.each {|line|
					items = line.chomp.split(/,/, 4)
					@logs << {
						:TIME	=> Time.at(items[0].to_i),
						:USER	=> items[1],
						:FACE	=> items[2],
						:TEXT	=> items[3],
					}
					(n -= 1) < 1 and break
				}
			} rescue(true)
			n < 1 and break
			cur_month -= 28 * 24 * 60 * 60 while((it = cur_month.strftime(@log_name)) == log_file)
			log_file = it
		}
	end

	def get_log(n)
		(it = @logs[n]) ? it : { :TIME => Time.at(0), :USER => '', :FACE => '', :TEXT => '' }
	end
end

__END__

